/ / Gibt es eine Möglichkeit, programmgesteuert auf eine Liste von Abschlusskandidaten in Zsh zuzugreifen und diese zu speichern? - zsh, autocomplete

Gibt es eine Möglichkeit, programmgesteuert auf eine Liste von Abschlusskandidaten in Zsh zuzugreifen und diese zu speichern? - zsh, autocomplete

In Zsh standardm√§√üig die Tab Schl√ľssel ist gebunden an expand-or-complete. Ich m√∂chte programmatisch auf die Liste der Vervollst√§ndigungskandidaten zugreifen, die von press erstellt worden w√§ren Tab, damit ich meine eigene Funktion schreiben und die Liste selbst filtern kann. Ich verstehe, dass es ein "Abschluss-Framework" gibt, das mit Zsh geliefert wird, aber ich w√ľrde es gerne selbst tun.

Es gibt auch die list-choices Funktion / Widget, die die gleiche Ausgabe wie erzeugt expand-or-complete Bietet jedoch nicht die Funktion zum Wechseln zwischen Registerkarten.

Ich habe eine einigerma√üen umfangreiche Suche bei Google durchgef√ľhrt und auch die Zsh-Quelle durchgesehen, kam aber trocken. F√ľr jede Hilfe w√§re ich dankbar.

Antworten:

4 f√ľr Antwort ‚ĄĖ 1

Indirekt dank JakeGould bin ich auf eine Lösung gestoßen: zsh-capture-completion. Eigentlich gibt es zwei andere Fast identische Fragen auf den Unix Stack Exchange-Sites, beide mit der Antwort, die ich hier gegeben habe.

Skript-Quellcode f√ľr zsh-capture-completion finden Sie hier:

#!/bin/zsh

zmodload zsh/zpty || { echo "error: missing module zsh/zpty" >&2; exit 1 }

# spawn shell
zpty z zsh -f -i

# line buffer for pty output
local line

setopt rcquotes
() {
zpty -w z source $1
repeat 4; do
zpty -r z line
[[ $line == ok* ]] && return
done
echo "error initializing." >&2
exit 2
} =( <<< "
# no prompt!
PROMPT=
# load completion system
autoload compinit
compinit -d ~/.zcompdump_capture
# never run a command
bindkey ""^M"" undefined
bindkey ""^J"" undefined
bindkey ""^I"" complete-word
# send a line with null-byte at the end before and after completions are output
null-line () {
echo -E - $""""
}
compprefuncs=( null-line )
comppostfuncs=( null-line exit )
# never group stuff!
zstyle "":completion:*"" list-grouped false
# don""t insert tab when attempting completion on empty line
zstyle "":completion:*"" insert-tab false
# no list separator, this saves some stripping later on
zstyle "":completion:*"" list-separator """"
# we use zparseopts
zmodload zsh/zutil
# override compadd (this our hook)
compadd () {
# check if any of -O, -A or -D are given
if [[ ${@[1,(i)(-|--)]} == *-(O|A|D) * ]]; then
# if that is the case, just delegate and leave
builtin compadd "$@"
return $?
fi
# ok, this concerns us!
# echo -E - got this: "$@"
# be careful with namespacing here, we don""t want to mess with stuff that
# should be passed to compadd!
typeset -a __hits __dscr __tmp
# do we have a description parameter?
# note we don""t use zparseopts here because of combined option parameters
# with arguments like -default- confuse it.
if (( $@[(I)-d] )); then # kind of a hack, $+@[(r)-d] doesn""t work because of line noise overload
# next param after -d
__tmp=${@[$[${@[(i)-d]}+1]]}
# description can be given as an array parameter name, or inline () array
if [[ $__tmp == (* ]]; then
eval "__dscr=$__tmp"
else
__dscr=( "${(@P)__tmp}" )
fi
fi
# capture completions by injecting -A parameter into the compadd call.
# this takes care of matching for us.
builtin compadd -A __hits -D __dscr "$@"
setopt localoptions norcexpandparam extendedglob
# extract prefixes and suffixes from compadd call. we can""t do zsh""s cool
# -r remove-func magic, but it""s better than nothing.
typeset -A apre hpre hsuf asuf
zparseopts -E P:=apre p:=hpre S:=asuf s:=hsuf
# append / to directories? we are only emulating -f in a half-assed way
# here, but it""s better than nothing.
integer dirsuf=0
# don""t be fooled by -default- >.>
if [[ -z $hsuf && "${${@//-default-/}% -# *}" == *-[[:alnum:]]#f* ]]; then
dirsuf=1
fi
# just drop
[[ -n $__hits ]] || return
# this is the point where we have all matches in $__hits and all
# descriptions in $__dscr!
# display all matches
local dsuf dscr
for i in {1..$#__hits}; do
# add a dir suffix?
(( dirsuf )) && [[ -d $__hits[$i] ]] && dsuf=/ || dsuf=
# description to be displayed afterwards
(( $#__dscr >= $i )) && dscr=" -- ${${__dscr[$i]}##$__hits[$i] #}" || dscr=
echo -E - $IPREFIX$apre$hpre$__hits[$i]$dsuf$hsuf$asuf$dscr
done
}
# signal success!
echo ok")

zpty -w z "$*"$"t"

integer tog=0
# read from the pty, and parse linewise
while zpty -r z; do :; done | while IFS= read -r line; do
if [[ $line == *$"r" ]]; then
(( tog++ )) && return 0 || continue
fi
# display between toggles
(( tog )) && echo -E - $line
done

return 2

Hier ist ein Beispiel f√ľr die Verwendung von Skripten:

‚ēź‚ēź‚Ėļ % cd ~/.zsh_plugins
‚ēź‚ēź‚Ėļ % zsh ./zsh-capture-completion/capture.zsh "cd "
zaw/
zsh-capture-completion/
zsh-syntax-highlighting/
zsh-vimode-visual/

Beachten Sie das Leerzeichen im obigen Befehl. Mit dem Platz bietet das Skript die Liste der Ordner, die Sie k√∂nnen cd in aus dem aktuellen Verzeichnis. Ohne sie w√ľrde das Skript alle Vervollst√§ndigungen f√ľr Befehle bereitstellen, die mit beginnen cd.

Ich sollte auch beachten, dass selbst der Autor dervorausgesetzt, Skript / Plugin h√§lt seine L√∂sung f√ľr "hacky". Wenn jemand eine k√ľrzere oder einfachere L√∂sung kennt, w√ľrde ich sie gerne als Antwort akzeptieren.